import peasy.*;
PeasyCam cam;
import controlP5.*;
//import processing.opengl.*;
Table duration;
Table amount;
Table amount_month;
int numRowsD, numColsD, numRowsA, numColsA, monthRows, monthCols;
float [][] MatrixD;
float [][] MatrixA;
float [][] MatrixMD;
float [][] MatrixMA;

float [][] month;
float[] spacers = {600, 610, 620, 630, 640, 650, 660, 670, 680, 690};
int SPHERE_NUM;
ArrayList<Sphere> spheres;
float ORBITAL_RADIOUS = 100;
float SPHERE_RADIOUS = 100;
float SPHERE_RADIAN_SPEED = 0;
float constant = 4;
float SR;
float radian1;
float radian2;
float radianSpeed1;
color [] colors = {#D9DDD8, #FBABA8, #98D0BF, #7DBFD5, #9A879D, #555854, #722e29, #1F4e40, #083f51, #353c42};  
//grey   , pink,   green, blue, purple,  dark grey, red, dark green,    dark blue,  black
int opacity = 50;
//int opacity2 = 0;
boolean year = false;
int years;
int position = -30;
PShape mercury;
PShape venus;
PShape earth;
PShape  mars;
PShape jupiter;
PShape saturn;
PShape uranus;
PShape neptune;
PShape pluto;
int o = 1;
float x, y, z;
ControlP5 cp5_1, cp5_2;
boolean mapTogglem = false, mapTogglev = false, mapTogglee = false, mapToggler = false, mapTogglej = false, mapToggles = false, mapTogglen = false, mapToggleu = false, mapTogglep =false;
int Maptype = 0;
CheckBox checkboxm, checkboxv, checkboxe, checkboxr, checkboxj, checkboxu, checkboxn, checkboxp, checkboxs;
CheckBox checkbox6, checkbox7, checkbox8, checkbox9, checkbox10, checkbox11, checkbox12, checkbox13, checkbox14, checkbox15, checkbox16;
int Planets = 0;
Textlabel myTextlabel;
//Slider abc;
//int space = 100;
//need to get each column to create a sphere
//call sphere class for each size of the sphere and rotation speed
//and then after all the years readjust the radius for the next dewey class
ControlWindow controlwindow;
void setup() {
  size(1000, 1000, P3D);
  cam = new PeasyCam(this, 300);
  cp5_1 = new ControlP5(this);
  cp5_1.setAutoDraw(false);
  cp5_2 = new ControlP5(this);
  cp5_2.setAutoDraw(false);
  //controlwindow= cp5_1.addControlWindow("cp5_1window",100,100,400,200);
  //controlwindow.setBackground(40);
  //checkbox.setWindow(controlwindow);
  //cp5.setAutoDraw(false);
  usercommands();

  duration = loadTable("planet_duration.csv", "header");
  amount = loadTable("planet_amount.csv", "header");
  amount_month = loadTable("amount_month.csv", "header");
  numRowsD = duration.getRowCount();
  numColsD = duration.getColumnCount();
  numRowsA = amount.getRowCount();
  numColsA = amount.getColumnCount();
  monthRows = amount_month.getRowCount();
  monthCols = amount_month.getColumnCount();
  //println(monthCols, monthRows);
  //println();

  for (int i=0; i< duration.getRowCount()-2; i++) {
    spacers[i] = map(spacers[i], 600, 690, 0, width);
    //spacers[i] = duration.getFloat(0,i);
  }
  //printArray(spacers);

  //println(numColsD);
  MatrixD = new float[numColsD][numRowsD];
  MatrixA = new float[numColsA][numRowsA];
  MatrixMD = new float[numColsD][numRowsD];
  MatrixMA =  new float [numColsA][numRowsA];
  month = new float[monthRows][monthCols];

  //i = rows and j = cols
  for ( int i = 0; i < numRowsD; i++) {
    for (int j = 1; j < numColsD-1; j++) {
      MatrixD[i][j] = duration.getFloat(i, j);
      MatrixMD[i][j] = map(duration.getFloat(i, j), 0, 100, 0, width);
      //printArray(MatrixD[i][j]);
    }
  }
  for (int i =0; i < monthRows; i++) {
    for (int j = 0; j < monthCols; j++) {
      month[i][j] = amount_month.getFloat(i, j);
      //println("J: " +j);
      // printArray(month[i][j]);
    }
  }

  planet_setup();

  for ( int i = 0; i < numRowsA; i++) {
    for (int j = 1; j < numColsA-1; j++) {
      MatrixA[i][j] = amount.getFloat(i, j);
      MatrixMA[i][j] = map(duration.getFloat(i, j), 0, 100, 0, width);
    }
  }
}
void draw() {
  background(0);
  //surface.setResizable(true);
  //  if (cp5_1.window(this).isMouseOver()) {
  //  cam.setActive(false);
  //} else {
  //  cam.setActive(true);
  //}

  hint(ENABLE_DEPTH_TEST);
  cam.beginHUD();
  cp5_1.draw();
  cp5_2.draw();
  cam.endHUD();
  hint(DISABLE_DEPTH_TEST);

  //println(Maptype);
  if (mapTogglem) {
    pushMatrix(); 
    translate(width/2, height/2);
    scale(0.02);
    shape(mercury, width/2, height/2);
    popMatrix();
  }

  if (mapTogglev) {
    pushMatrix(); 
    translate(width/2, height/2, spacers[1]);
    scale(0.02);
    shape(venus, width/2, height/2);
    popMatrix();
  }
  if (mapTogglee) {
    pushMatrix(); 
    translate(width/2, height/2, spacers[2]);
    scale(0.02);
    shape(earth, width/2, height/2);
    popMatrix();
  }
  if (mapToggler) {
    pushMatrix(); 
    translate(width/2, height/2, spacers[3]);
    scale(0.02);
    shape(mars, width/2, height/2);
    popMatrix();
  }
  if (mapTogglej) {
    pushMatrix(); 
    translate(width/2, height/2, spacers[4]);
    scale(0.02);
    shape(jupiter, width/2, height/2);
    popMatrix();
  }
  if (mapToggles) {
    pushMatrix(); 
    translate(width/2, height/2, spacers[5]);
    scale(0.02);
    shape(saturn, width/2, height/2);
    popMatrix();
  }
  if (mapToggleu) {
    pushMatrix(); 
    translate(width/2, height/2, spacers[6]);
    scale(0.02);
    shape(uranus, width/2, height/2);
    popMatrix();
  }
  if (mapTogglen) {
    pushMatrix(); 
    translate(width/2, height/2, spacers[7]);
    scale(0.02);
    shape(neptune, width/2, height/2);
    popMatrix();
  }
  if (mapTogglep) {
    pushMatrix(); 
    translate(width/2, height/2, spacers[8]);
    scale(0.02);
    shape(pluto, width/2, height/2);
    popMatrix();
  }

  for (int i =0; i < 4; i++) {
    pushMatrix();
    noFill();
    translate(width/2, height/2, spacers[i]);
    stroke(255, opacity);
    ellipse(0, 0, spacers[1]*12+i*300+100, spacers[1]*12+i*300+100);
    popMatrix();
    //o = 1;
  }
  for (int i =4; i <9; i++) {
    pushMatrix();
    noFill();
    translate(width/2, height/2, spacers[i]);
    stroke(255, opacity);
    ellipse(0, 0, spacers[1]*12+i*300+80+100, spacers[1]*12+i*300+80+100);
    popMatrix();
  }
  ArrayList<Sphere> spheres = new ArrayList<Sphere>();
  int k = 0;
  for ( int i = 0; i < numRowsA; i++) {
    if (k<numColsA-2) {
      for (int j = 1; j < numColsA-1; j++) {
        if (!year) {
          Sphere a = new Sphere(MatrixD[i][j], MatrixA[i][j], spacers[k], colors[j-1]);
          spheres.add(a);
        } else {
          Sphere a = new Sphere(MatrixD[i][years], MatrixA[i][years], spacers[k], colors[years-1]);
          spheres.add(a);
        }
      }
    }
    k+=1;
  }
  //println();
  for (int i = 0; i < spheres.size(); i++) {
    spheres.get(i).sphere_draw();
    spheres.get(i).update();
  }
}